package de.prototype.dsl.ui.contentassist.antlr.internal; 

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ui.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ui.editor.contentassist.antlr.internal.DFA;
import de.prototype.dsl.services.PCMXtextGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalPCMXtextParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'obj'", "';'"
    };
    public static final int RULE_ID=4;
    public static final int RULE_STRING=6;
    public static final int T__12=12;
    public static final int T__11=11;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_INT=5;
    public static final int RULE_WS=9;
    public static final int RULE_SL_COMMENT=8;
    public static final int EOF=-1;
    public static final int RULE_ML_COMMENT=7;

    // delegates
    // delegators


        public InternalPCMXtextParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalPCMXtextParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalPCMXtextParser.tokenNames; }
    public String getGrammarFileName() { return "../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g"; }


     
     	private PCMXtextGrammarAccess grammarAccess;
     	
        public void setGrammarAccess(PCMXtextGrammarAccess grammarAccess) {
        	this.grammarAccess = grammarAccess;
        }
        
        @Override
        protected Grammar getGrammar() {
        	return grammarAccess.getGrammar();
        }
        
        @Override
        protected String getValueForTokenName(String tokenName) {
        	return tokenName;
        }




    // $ANTLR start "entryRuleModel"
    // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:60:1: entryRuleModel : ruleModel EOF ;
    public final void entryRuleModel() throws RecognitionException {
        try {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:61:1: ( ruleModel EOF )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:62:1: ruleModel EOF
            {
             before(grammarAccess.getModelRule()); 
            pushFollow(FOLLOW_ruleModel_in_entryRuleModel61);
            ruleModel();

            state._fsp--;

             after(grammarAccess.getModelRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleModel68); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleModel"


    // $ANTLR start "ruleModel"
    // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:69:1: ruleModel : ( ( rule__Model__ObjsAssignment )* ) ;
    public final void ruleModel() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:73:2: ( ( ( rule__Model__ObjsAssignment )* ) )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:74:1: ( ( rule__Model__ObjsAssignment )* )
            {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:74:1: ( ( rule__Model__ObjsAssignment )* )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:75:1: ( rule__Model__ObjsAssignment )*
            {
             before(grammarAccess.getModelAccess().getObjsAssignment()); 
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:76:1: ( rule__Model__ObjsAssignment )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==11) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:76:2: rule__Model__ObjsAssignment
            	    {
            	    pushFollow(FOLLOW_rule__Model__ObjsAssignment_in_ruleModel94);
            	    rule__Model__ObjsAssignment();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

             after(grammarAccess.getModelAccess().getObjsAssignment()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleModel"


    // $ANTLR start "entryRuleObject"
    // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:88:1: entryRuleObject : ruleObject EOF ;
    public final void entryRuleObject() throws RecognitionException {
        try {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:89:1: ( ruleObject EOF )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:90:1: ruleObject EOF
            {
             before(grammarAccess.getObjectRule()); 
            pushFollow(FOLLOW_ruleObject_in_entryRuleObject122);
            ruleObject();

            state._fsp--;

             after(grammarAccess.getObjectRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleObject129); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleObject"


    // $ANTLR start "ruleObject"
    // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:97:1: ruleObject : ( ( rule__Object__Group__0 ) ) ;
    public final void ruleObject() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:101:2: ( ( ( rule__Object__Group__0 ) ) )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:102:1: ( ( rule__Object__Group__0 ) )
            {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:102:1: ( ( rule__Object__Group__0 ) )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:103:1: ( rule__Object__Group__0 )
            {
             before(grammarAccess.getObjectAccess().getGroup()); 
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:104:1: ( rule__Object__Group__0 )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:104:2: rule__Object__Group__0
            {
            pushFollow(FOLLOW_rule__Object__Group__0_in_ruleObject155);
            rule__Object__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getObjectAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleObject"


    // $ANTLR start "rule__Object__Group__0"
    // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:118:1: rule__Object__Group__0 : rule__Object__Group__0__Impl rule__Object__Group__1 ;
    public final void rule__Object__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:122:1: ( rule__Object__Group__0__Impl rule__Object__Group__1 )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:123:2: rule__Object__Group__0__Impl rule__Object__Group__1
            {
            pushFollow(FOLLOW_rule__Object__Group__0__Impl_in_rule__Object__Group__0189);
            rule__Object__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Object__Group__1_in_rule__Object__Group__0192);
            rule__Object__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Object__Group__0"


    // $ANTLR start "rule__Object__Group__0__Impl"
    // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:130:1: rule__Object__Group__0__Impl : ( 'obj' ) ;
    public final void rule__Object__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:134:1: ( ( 'obj' ) )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:135:1: ( 'obj' )
            {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:135:1: ( 'obj' )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:136:1: 'obj'
            {
             before(grammarAccess.getObjectAccess().getObjKeyword_0()); 
            match(input,11,FOLLOW_11_in_rule__Object__Group__0__Impl220); 
             after(grammarAccess.getObjectAccess().getObjKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Object__Group__0__Impl"


    // $ANTLR start "rule__Object__Group__1"
    // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:149:1: rule__Object__Group__1 : rule__Object__Group__1__Impl rule__Object__Group__2 ;
    public final void rule__Object__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:153:1: ( rule__Object__Group__1__Impl rule__Object__Group__2 )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:154:2: rule__Object__Group__1__Impl rule__Object__Group__2
            {
            pushFollow(FOLLOW_rule__Object__Group__1__Impl_in_rule__Object__Group__1251);
            rule__Object__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Object__Group__2_in_rule__Object__Group__1254);
            rule__Object__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Object__Group__1"


    // $ANTLR start "rule__Object__Group__1__Impl"
    // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:161:1: rule__Object__Group__1__Impl : ( ( rule__Object__NameAssignment_1 ) ) ;
    public final void rule__Object__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:165:1: ( ( ( rule__Object__NameAssignment_1 ) ) )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:166:1: ( ( rule__Object__NameAssignment_1 ) )
            {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:166:1: ( ( rule__Object__NameAssignment_1 ) )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:167:1: ( rule__Object__NameAssignment_1 )
            {
             before(grammarAccess.getObjectAccess().getNameAssignment_1()); 
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:168:1: ( rule__Object__NameAssignment_1 )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:168:2: rule__Object__NameAssignment_1
            {
            pushFollow(FOLLOW_rule__Object__NameAssignment_1_in_rule__Object__Group__1__Impl281);
            rule__Object__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getObjectAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Object__Group__1__Impl"


    // $ANTLR start "rule__Object__Group__2"
    // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:178:1: rule__Object__Group__2 : rule__Object__Group__2__Impl rule__Object__Group__3 ;
    public final void rule__Object__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:182:1: ( rule__Object__Group__2__Impl rule__Object__Group__3 )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:183:2: rule__Object__Group__2__Impl rule__Object__Group__3
            {
            pushFollow(FOLLOW_rule__Object__Group__2__Impl_in_rule__Object__Group__2311);
            rule__Object__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Object__Group__3_in_rule__Object__Group__2314);
            rule__Object__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Object__Group__2"


    // $ANTLR start "rule__Object__Group__2__Impl"
    // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:190:1: rule__Object__Group__2__Impl : ( ( rule__Object__ReferenceAssignment_2 ) ) ;
    public final void rule__Object__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:194:1: ( ( ( rule__Object__ReferenceAssignment_2 ) ) )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:195:1: ( ( rule__Object__ReferenceAssignment_2 ) )
            {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:195:1: ( ( rule__Object__ReferenceAssignment_2 ) )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:196:1: ( rule__Object__ReferenceAssignment_2 )
            {
             before(grammarAccess.getObjectAccess().getReferenceAssignment_2()); 
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:197:1: ( rule__Object__ReferenceAssignment_2 )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:197:2: rule__Object__ReferenceAssignment_2
            {
            pushFollow(FOLLOW_rule__Object__ReferenceAssignment_2_in_rule__Object__Group__2__Impl341);
            rule__Object__ReferenceAssignment_2();

            state._fsp--;


            }

             after(grammarAccess.getObjectAccess().getReferenceAssignment_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Object__Group__2__Impl"


    // $ANTLR start "rule__Object__Group__3"
    // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:207:1: rule__Object__Group__3 : rule__Object__Group__3__Impl ;
    public final void rule__Object__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:211:1: ( rule__Object__Group__3__Impl )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:212:2: rule__Object__Group__3__Impl
            {
            pushFollow(FOLLOW_rule__Object__Group__3__Impl_in_rule__Object__Group__3371);
            rule__Object__Group__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Object__Group__3"


    // $ANTLR start "rule__Object__Group__3__Impl"
    // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:218:1: rule__Object__Group__3__Impl : ( ';' ) ;
    public final void rule__Object__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:222:1: ( ( ';' ) )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:223:1: ( ';' )
            {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:223:1: ( ';' )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:224:1: ';'
            {
             before(grammarAccess.getObjectAccess().getSemicolonKeyword_3()); 
            match(input,12,FOLLOW_12_in_rule__Object__Group__3__Impl399); 
             after(grammarAccess.getObjectAccess().getSemicolonKeyword_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Object__Group__3__Impl"


    // $ANTLR start "rule__Model__ObjsAssignment"
    // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:246:1: rule__Model__ObjsAssignment : ( ruleObject ) ;
    public final void rule__Model__ObjsAssignment() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:250:1: ( ( ruleObject ) )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:251:1: ( ruleObject )
            {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:251:1: ( ruleObject )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:252:1: ruleObject
            {
             before(grammarAccess.getModelAccess().getObjsObjectParserRuleCall_0()); 
            pushFollow(FOLLOW_ruleObject_in_rule__Model__ObjsAssignment443);
            ruleObject();

            state._fsp--;

             after(grammarAccess.getModelAccess().getObjsObjectParserRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__ObjsAssignment"


    // $ANTLR start "rule__Object__NameAssignment_1"
    // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:261:1: rule__Object__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Object__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:265:1: ( ( RULE_ID ) )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:266:1: ( RULE_ID )
            {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:266:1: ( RULE_ID )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:267:1: RULE_ID
            {
             before(grammarAccess.getObjectAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Object__NameAssignment_1474); 
             after(grammarAccess.getObjectAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Object__NameAssignment_1"


    // $ANTLR start "rule__Object__ReferenceAssignment_2"
    // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:276:1: rule__Object__ReferenceAssignment_2 : ( ( RULE_ID ) ) ;
    public final void rule__Object__ReferenceAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:280:1: ( ( ( RULE_ID ) ) )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:281:1: ( ( RULE_ID ) )
            {
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:281:1: ( ( RULE_ID ) )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:282:1: ( RULE_ID )
            {
             before(grammarAccess.getObjectAccess().getReferenceBasicComponentCrossReference_2_0()); 
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:283:1: ( RULE_ID )
            // ../de.prototype.dsl.ui/src-gen/de/prototype/dsl/ui/contentassist/antlr/internal/InternalPCMXtext.g:284:1: RULE_ID
            {
             before(grammarAccess.getObjectAccess().getReferenceBasicComponentIDTerminalRuleCall_2_0_1()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Object__ReferenceAssignment_2509); 
             after(grammarAccess.getObjectAccess().getReferenceBasicComponentIDTerminalRuleCall_2_0_1()); 

            }

             after(grammarAccess.getObjectAccess().getReferenceBasicComponentCrossReference_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Object__ReferenceAssignment_2"

    // Delegated rules


 

    public static final BitSet FOLLOW_ruleModel_in_entryRuleModel61 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleModel68 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Model__ObjsAssignment_in_ruleModel94 = new BitSet(new long[]{0x0000000000000802L});
    public static final BitSet FOLLOW_ruleObject_in_entryRuleObject122 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleObject129 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Object__Group__0_in_ruleObject155 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Object__Group__0__Impl_in_rule__Object__Group__0189 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Object__Group__1_in_rule__Object__Group__0192 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_11_in_rule__Object__Group__0__Impl220 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Object__Group__1__Impl_in_rule__Object__Group__1251 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Object__Group__2_in_rule__Object__Group__1254 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Object__NameAssignment_1_in_rule__Object__Group__1__Impl281 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Object__Group__2__Impl_in_rule__Object__Group__2311 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_rule__Object__Group__3_in_rule__Object__Group__2314 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Object__ReferenceAssignment_2_in_rule__Object__Group__2__Impl341 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Object__Group__3__Impl_in_rule__Object__Group__3371 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_12_in_rule__Object__Group__3__Impl399 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleObject_in_rule__Model__ObjsAssignment443 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Object__NameAssignment_1474 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Object__ReferenceAssignment_2509 = new BitSet(new long[]{0x0000000000000002L});

}