package de.prototype.dsl.parser.antlr.internal; 

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import de.prototype.dsl.services.PCMXtextGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalPCMXtextParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'obj'", "';'"
    };
    public static final int RULE_ID=4;
    public static final int RULE_STRING=6;
    public static final int T__12=12;
    public static final int T__11=11;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_INT=5;
    public static final int RULE_WS=9;
    public static final int RULE_SL_COMMENT=8;
    public static final int EOF=-1;
    public static final int RULE_ML_COMMENT=7;

    // delegates
    // delegators


        public InternalPCMXtextParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalPCMXtextParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalPCMXtextParser.tokenNames; }
    public String getGrammarFileName() { return "../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g"; }



     	private PCMXtextGrammarAccess grammarAccess;
     	
        public InternalPCMXtextParser(TokenStream input, PCMXtextGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }
        
        @Override
        protected String getFirstRuleName() {
        	return "Model";	
       	}
       	
       	@Override
       	protected PCMXtextGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}



    // $ANTLR start "entryRuleModel"
    // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:67:1: entryRuleModel returns [EObject current=null] : iv_ruleModel= ruleModel EOF ;
    public final EObject entryRuleModel() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleModel = null;


        try {
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:68:2: (iv_ruleModel= ruleModel EOF )
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:69:2: iv_ruleModel= ruleModel EOF
            {
             newCompositeNode(grammarAccess.getModelRule()); 
            pushFollow(FOLLOW_ruleModel_in_entryRuleModel75);
            iv_ruleModel=ruleModel();

            state._fsp--;

             current =iv_ruleModel; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleModel85); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleModel"


    // $ANTLR start "ruleModel"
    // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:76:1: ruleModel returns [EObject current=null] : ( (lv_objs_0_0= ruleObject ) )* ;
    public final EObject ruleModel() throws RecognitionException {
        EObject current = null;

        EObject lv_objs_0_0 = null;


         enterRule(); 
            
        try {
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:79:28: ( ( (lv_objs_0_0= ruleObject ) )* )
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:80:1: ( (lv_objs_0_0= ruleObject ) )*
            {
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:80:1: ( (lv_objs_0_0= ruleObject ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==11) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:81:1: (lv_objs_0_0= ruleObject )
            	    {
            	    // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:81:1: (lv_objs_0_0= ruleObject )
            	    // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:82:3: lv_objs_0_0= ruleObject
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getModelAccess().getObjsObjectParserRuleCall_0()); 
            	    	    
            	    pushFollow(FOLLOW_ruleObject_in_ruleModel130);
            	    lv_objs_0_0=ruleObject();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getModelRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"objs",
            	            		lv_objs_0_0, 
            	            		"Object");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleModel"


    // $ANTLR start "entryRuleObject"
    // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:106:1: entryRuleObject returns [EObject current=null] : iv_ruleObject= ruleObject EOF ;
    public final EObject entryRuleObject() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleObject = null;


        try {
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:107:2: (iv_ruleObject= ruleObject EOF )
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:108:2: iv_ruleObject= ruleObject EOF
            {
             newCompositeNode(grammarAccess.getObjectRule()); 
            pushFollow(FOLLOW_ruleObject_in_entryRuleObject166);
            iv_ruleObject=ruleObject();

            state._fsp--;

             current =iv_ruleObject; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleObject176); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleObject"


    // $ANTLR start "ruleObject"
    // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:115:1: ruleObject returns [EObject current=null] : (otherlv_0= 'obj' ( (lv_name_1_0= RULE_ID ) ) ( (otherlv_2= RULE_ID ) ) otherlv_3= ';' ) ;
    public final EObject ruleObject() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_3=null;

         enterRule(); 
            
        try {
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:118:28: ( (otherlv_0= 'obj' ( (lv_name_1_0= RULE_ID ) ) ( (otherlv_2= RULE_ID ) ) otherlv_3= ';' ) )
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:119:1: (otherlv_0= 'obj' ( (lv_name_1_0= RULE_ID ) ) ( (otherlv_2= RULE_ID ) ) otherlv_3= ';' )
            {
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:119:1: (otherlv_0= 'obj' ( (lv_name_1_0= RULE_ID ) ) ( (otherlv_2= RULE_ID ) ) otherlv_3= ';' )
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:119:3: otherlv_0= 'obj' ( (lv_name_1_0= RULE_ID ) ) ( (otherlv_2= RULE_ID ) ) otherlv_3= ';'
            {
            otherlv_0=(Token)match(input,11,FOLLOW_11_in_ruleObject213); 

                	newLeafNode(otherlv_0, grammarAccess.getObjectAccess().getObjKeyword_0());
                
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:123:1: ( (lv_name_1_0= RULE_ID ) )
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:124:1: (lv_name_1_0= RULE_ID )
            {
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:124:1: (lv_name_1_0= RULE_ID )
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:125:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleObject230); 

            			newLeafNode(lv_name_1_0, grammarAccess.getObjectAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getObjectRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:141:2: ( (otherlv_2= RULE_ID ) )
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:142:1: (otherlv_2= RULE_ID )
            {
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:142:1: (otherlv_2= RULE_ID )
            // ../de.prototype.dsl/src-gen/de/prototype/dsl/parser/antlr/internal/InternalPCMXtext.g:143:3: otherlv_2= RULE_ID
            {

            			if (current==null) {
            	            current = createModelElement(grammarAccess.getObjectRule());
            	        }
                    
            otherlv_2=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleObject255); 

            		newLeafNode(otherlv_2, grammarAccess.getObjectAccess().getReferenceBasicComponentCrossReference_2_0()); 
            	

            }


            }

            otherlv_3=(Token)match(input,12,FOLLOW_12_in_ruleObject267); 

                	newLeafNode(otherlv_3, grammarAccess.getObjectAccess().getSemicolonKeyword_3());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleObject"

    // Delegated rules


 

    public static final BitSet FOLLOW_ruleModel_in_entryRuleModel75 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleModel85 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleObject_in_ruleModel130 = new BitSet(new long[]{0x0000000000000802L});
    public static final BitSet FOLLOW_ruleObject_in_entryRuleObject166 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleObject176 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_11_in_ruleObject213 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleObject230 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleObject255 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_ruleObject267 = new BitSet(new long[]{0x0000000000000002L});

}